;*********************************************************;
;							  ;
;     SBC-2 v2.5 Video Display Driver (c)2003-2004	  ;
;                        v1.0  				  ;
;                  by Daryl Rictor   			  ;
;							  ;
;*********************************************************;
;======================================================================
; Serial Shift Register Routines
; *** assumes Bit 7 of port B is used for Handshake
;======================================================================
;
; 6522 Definitions from SBC-4 - adjust this to your system.
;
Vportb	=  $0280		; VIA1 Port B
Vddrb	=  $0282		; VIA1 Port B DDR
Vsr	=  $028A		; VIA1 Shift Register
Vacr	=  $028B		; VIA1 ACR
Vifr	=  $028D		; Via1 IFR bit 1
Vier	=  $028E		; Via1 IER

	*= $1000
;----------------------------------------------------------------------
; Call this to write the byte in the Accumulator to the display
; Note - at PHI2 clock rate, the SR will always be ready to shift 
; another byte upon entry to this routine so we don't test it.
; We only test the AVR to be sure it is ready for the next byte.
;----------------------------------------------------------------------

	jsr	cls
	lda	#$60
	sta	fast		; null the fast delay


cls	lda	#$0c
	jsr	voutput
	
	jsr	dfox

	ldx	#$06
scup	lda	#$EC
	jsr	voutput
	dex
	bne	scup


	ldx	#$06
scdn	lda	#$ED
	jsr	voutput
	dex
	bne	scdn

	ldx	#$06
scrt	lda	#$EF
	jsr	voutput
	dex
	bne	scrt

	ldx	#$06
sclf	lda	#$EE
	jsr	voutput
	dex
	bne	sclf

CHm	lda	#$BA
	jsr	voutput

	ldx	#$0f
cdn	lda	#$ED
	jsr	voutput
	dex
	bne	cdn

	ldx	#$06
cup	lda	#$E8
	jsr	voutput
	dex
	bne	cup

	ldx	#$20
crt	lda	#$EB
	jsr	voutput
	dex
	bne	crt

	ldx	#$10
clf	lda	#$EA
	jsr	voutput
	dex
	bne	clf

cblk	lda	#$BC
	jsr	voutput

	ldx	#$10
CHm1	lda	#$BA
	jsr	voutput
	dex
	bne	cHm1

	rts

dfox	jsr	pfox
	jsr	pfox
	jsr	pfox
	jsr	pfox
	jsr	pfox
	jsr	pfox
	jsr	pfox
	jsr	pfox
	jsr	pfox
	jsr	pfox
	jsr	pfox
	jsr	pfox
	jsr	pfox
	jsr	pfox
	jsr	pfox
	jsr	pfox
	jsr	pfox
	jsr	pfox

pfox	ldx	#$00
pf1	lda	fox,x
	inx
	cmp	#"="
	beq	pf2
	jsr	voutput
	bra	pf1
pf2	rts


FOX	.byte	"The quick brown fox jumps over the lazy dog's back. ="


VOutput
	bit  vportb		; 4 read handshake byte
	bmi  Voutput		; 2/3 if 0, wait for AVR to be ready
	sta  vsr		; send to display via serial port
VOutput1
	bit  vportb		; 4 read handshake byte
	bpl  Voutput1		; 2/3 if 0, wait for AVR to be ready

fast	LDY  #$80
	LDA  #$00
VLOOP	DEC
	BNE  VLOOP
	DEY
	BNE	VLOOP

	rts			; return

;----------------------------------------------------------------------
; Call this once to initialize the interface
; it sets up Port A as an output port and enables Handshaking	
;----------------------------------------------------------------------
VInitDisp			
	sei			; disable interrupts
	lda  Vddrb		; get ddr b
	and  #$7F		; mask bit 7
	sta  vddrb		; set bit 7 to 0 (input)
	lda  vacr		; get ACR contents
	and  #$E3		; mask bits 2,3,4
	ora  #$18		; set Shift out under control of PHI2 mode
	sta  vacr		; store to acr
	and  #$04		; mask shift register flag
	sta  vier		; disable shift register interrupts
	cli			; Enable Interrupts again
	rts			; done

;----------------------------------------------------------------------
; End of Program.
;----------------------------------------------------------------------

