;
;  Define Registers and Port Pins
;
;   Acc = R00, R01 (results of multiply command)
.def  Acc		=	R0			;\ math accumulator
.def  Acch		=	R1			;/ 



; refresh registers

.def  top		=	R4
.def  left		=	R5
.def  scanln	=	R6
.def  scanlnh	=	R7
.def  scanend	=	R8
.def  vend		=	R9
.def  numlines	=	R10

.def  savsr		=	R11			; Status reg temp save
.def  svz		=	R12			;\ Acc reg temp save
.def  svzh		=	R13			;/
.def  svacc		=	R14			;\ Acc reg temp save
.def  svacch	=	R15			;/
.def  vline		=	R24			;\ vertical display line counter 0-239
.def  vlineH	=	R25			;/
;    X pair = R26,27
;    Z pair = R30,31


; Application registers
;-------------------------------------------------
.def  fnthl		=	R2			; normal=0x00, inv = 0x80
.def  fntsel	=   R3			; Font Select, 00 = Primary, 08 = Alternate

.def  i			=	R16			; scratch 8 bit reg
.def  j			=	R17			; scratch 8 bit reg
.def  CursCtl	=	R18			; scratch 8 bit reg
.def  Cursclk	=	R19			; scratch 8 bit reg
.def  inpt		=	R20			; input character
.def  hpos		=	R21			; hor cursor pos  0-39
.def  vpos		=	R22			; vert cursor pos 0-24
.def  curschr	=	R23			; constant 40 (used everywhere)
;    Y pair = R28,29
;    Z pair = R30,31
;
;  X pair used to point to SRAM by refresh routines
;  Y pair used to point to SRAM by HOST processor
;  Z pair used to point to Font data in Program Memory

; Port D defs
.set  syncpin 	=	PD2			; output
.set  ssclk		=	PD4			; shift clk (not used)
.set  vdata		=	PD1			; output (UART-SPI TX)
;-----------------------------------------

;PORT B pin defs
.set  hsp		=	PB1			; output - host handshake
.set  sdp		=	PB3			; input - host serial clock
.set  scp		=	PB5			; input - host serial data

;PORT C pin defs
.set  palp		=	PC5			; input - PAL select when low
.set  rstpin	=	PC6			; input - reset

;PORT D defs - video/host data bus
.set  vdout		=	PD1			; ouput - video data
.set  syncpin	=	PD2			; ouput - video sync
.set  xclk		=	PD4			; uart SPI sclk - not used but initialized







